


let IsTimeStoppedPseudo = false;

let IsShaderActive = 0;
let IsBackgroundBlastActive = false;


let TargetPriorities = [];

let timestopl1duration = 0;

let pixelSrc = "";
local{
	ShaderCheck;
	pixelSrc = GetCurrentScriptDirectory;
}

let libSrc = pixelSrc~"shader/";
let maskSrc = pixelSrc~"img/Masks/";

//let timezonescale = 1.15-argument/360;

task ShaderCheck{

}

function SetNewPriorityRange(min, max){
	let dist = max-min;
	
	ascent(i in 0..length(TargetPriorities)){
		let tp = TargetPriorities[i];
		if(tp >= min && tp <= max){
		
		}
	}
	
}

task TimeStopL1(r, g, b, bw, spd, duration, minpri, maxpri){
	let RecoveryTime = 14;
	let bspeed = GetCommonData("stgspeed", 4);
	if(quality < 2){ModifyBGSpeedNonShader;return;}
	IsShaderActive++;
	r = (255-r)/255;
	g = (255-g)/255;
	b = (255-b)/255;
	
	let pathShader = libSrc~"colorTint.hlsl";
	
	let objShader = ObjPrim_Create(OBJ_SPRITE_2D);
	ObjShader_SetShaderF(objShader, pathShader);
	ObjShader_SetTechnique(objShader, "TecColor");
	ObjShader_SetFloat(objShader, "s_bw", bw);

	SetShaderI(objShader, minpri, maxpri);
	
	ModifyBGSpeedShader;
	
	ascent(i in 0..duration-RecoveryTime){
		if(!PHold(1)){break;}
	}	
	ascent(i in 0..RecoveryTime){
		if(!PHold(1)){break;}
	}
	IsShaderActive--;
	ObjShader_ResetShader(objShader);
	ResetShaderI(minpri, maxpri);
	Obj_Delete(objShader);
	
	
	task ModifyBGSpeedShader{
		if(bw == 0){
			let targetspd = spd-bspeed;
			let targetclock = spd-1;
			ascent(i in 0..RecoveryTime){
				ObjShader_SetFloat(objShader, "s_red", 1-r/RecoveryTime*i);
				ObjShader_SetFloat(objShader, "s_green", 1-g/RecoveryTime*i);
				ObjShader_SetFloat(objShader, "s_blue", 1-b/RecoveryTime*i);
				SetCommonData("stgspeed", bspeed+targetspd/RecoveryTime*i);
				SetCommonData("clockspeed", 1+targetclock/RecoveryTime*i);
				if(!PHold(1)){break;}
			}
			ascent(i in 0..duration-RecoveryTime*2){if(!PHold(1)){break;}}
			descent(i in 0..RecoveryTime){
				ObjShader_SetFloat(objShader, "s_red", 1-r/RecoveryTime*i);
				ObjShader_SetFloat(objShader, "s_green", 1-g/RecoveryTime*i);
				ObjShader_SetFloat(objShader, "s_blue", 1-b/RecoveryTime*i);
				SetCommonData("stgspeed", bspeed+targetspd/RecoveryTime*i);
				SetCommonData("clockspeed", 1+targetclock/RecoveryTime*i);
				if(!PHold(1)){break;}
			}
		}else{
			SetCommonData("stgspeed", 0);
			SetCommonData("clockspeed", 0);
			ObjShader_SetFloat(objShader, "s_red", 1);
			ascent(i in 0..duration-RecoveryTime){if(!PHold(1)){break;}}
			ascent(i in 0..RecoveryTime){
				ObjShader_SetFloat(objShader, "s_red", 1-1/RecoveryTime*i);
				SetCommonData("stgspeed", bspeed/RecoveryTime*i);
				SetCommonData("clockspeed", 1/RecoveryTime*i);
				if(!PHold(1)){break;}
			}
		}
		SetCommonData("stgspeed", bspeed);
	}
	
	task ModifyBGSpeedNonShader{
		let obj = ObjPrim_Create(OBJ_SPRITE_2D);
		ObjRender_SetBlendType(obj, BLEND_ADD_RGB);
		ObjRender_SetAlpha(obj, 255);
		Obj_SetRenderPriority(obj, maxpri);
		ObjPrim_SetTexture(obj, NULL);
		ObjSprite2D_SetSourceRect(obj, 0, 0, 2, 2);
		ObjSprite2D_SetDestRect(obj, 32, 16, GetStgFrameWidth+32, GetStgFrameHeight+16);
		ObjRender_SetPermitCamera(obj, false);
		
		
		let palph = 0;
		ObjRender_SetColor(obj, r*0.2*palph, g*0.2*palph, b*0.2*palph);
		
		if(bw == 0){
			let targetspd = spd-bspeed;
			let targetclock = spd-1;
			ascent(i in 0..RecoveryTime){
				palph = i/RecoveryTime;
				ObjRender_SetColor(obj, r*0.2*palph, g*0.2*palph, b*0.2*palph);
				SetCommonData("stgspeed", bspeed+targetspd/RecoveryTime*i);
				SetCommonData("clockspeed", 1+targetclock/RecoveryTime*i);
				if(!PHold(1)){break;}
			}
			palph = 1;
			ObjRender_SetColor(obj, r*0.2*palph, g*0.2*palph, b*0.2*palph);
			ascent(i in 0..duration-RecoveryTime*2){if(!PHold(1)){break;}}
			descent(i in 0..RecoveryTime){
				palph = i/RecoveryTime;
				ObjRender_SetColor(obj, r*0.2*palph, g*0.2*palph, b*0.2*palph);
				SetCommonData("stgspeed", bspeed+targetspd/RecoveryTime*i);
				SetCommonData("clockspeed", 1+targetclock/RecoveryTime*i);
				if(!PHold(1)){break;}
			}
		}else{
			SetCommonData("stgspeed", 0);
			SetCommonData("clockspeed", 0);
			ObjRender_SetBlendType(obj, BLEND_SUBTRACT);
			palph = 48;
			ObjRender_SetColor(obj, palph, palph, palph);
			ascent(i in 0..duration-RecoveryTime){if(!PHold(1)){break;}}
			ascent(i in 0..RecoveryTime){
				let ralph = palph-palph*i/RecoveryTime;
				ObjRender_SetColor(obj, ralph, ralph, ralph);
				SetCommonData("stgspeed", bspeed/RecoveryTime*i);
				SetCommonData("clockspeed", 1/RecoveryTime*i);
				if(!PHold(1)){break;}
			}
		}
		SetCommonData("stgspeed", bspeed);
		Obj_Delete(obj);
	}
}

//hackish way of implementing, IMPORTANT: remove the render target texture when attack is done
task BG_TimeStopL1(lockplayer, spd, duration, minpri, maxpri){
	let renderTexture = "SpellTimeStop";
	if(!CreateRenderTarget(renderTexture)){
	RaiseError("Not enough VRAM to proceed.\nTry restarting the game and lowering the graphics quality.");}
		
	// SetInvalidRenderPriorityA1(minpri, maxpri);
	// Reset2DCamera;
	RenderToTextureA1(renderTexture, minpri, maxpri, true);
	// ClearInvalidRenderPriority;
	
	let obj = ObjPrim_Create(OBJ_SPRITE_2D);
	Obj_SetRenderPriorityI(obj, maxpri+1);
	ObjPrim_SetTexture(obj, renderTexture);
	ObjSprite2D_SetSourceRect(obj, GetStgFrameLeft, GetStgFrameTop, GetStgFrameLeft+GetStgFrameWidth, GetStgFrameTop+GetStgFrameHeight);
	ObjSprite2D_SetDestRect(obj, 0, 0, GetStgFrameWidth, GetStgFrameHeight);
	
	SetCommonData("IsTimeStopped", true);
	TimeStopL1(255, 255, 255, 1, spd, duration, minpri, maxpri+1);
	
	let px = GetPlayerX;
	let py = GetPlayerY;
	
	loop(duration-20){
		if(lockplayer){ObjMove_SetPosition(GetPlayerObjectID, px, py);}
		yield;
	}
	ScreenShatterA1(maxpri+1, maxpri+2);
	loop(20){
		if(lockplayer){ObjMove_SetPosition(GetPlayerObjectID, px, py);}
		yield;
	}
	ClearInvalidRenderPriority;
	SetCommonData("IsTimeStopped", false);
	
	ObjRender_SetBlendType(obj, BLEND_SUBTRACT);
	
	
	descent(i in 0..12){
		// let alph = 64+128/14*i;
		let alph = 92*sin(30+150/11*i);
		ObjRender_SetColor(obj, alph, alph, alph);
		yield;
	}
	Obj_Delete(obj);
	RemoveTexture(renderTexture);
}


task MaskedShaderA1(obj, image, pri, xm, ym){
	MaskedShaderB1(obj, image, pri, xm, ym, 0);
}

task MaskedShaderB1(obj, image, pri, xm, ym, type){
	MaskedShaderC1(obj, image, pri, xm, ym, type, 1, 1, 1, 1);
}
task MaskedShaderC1(obj, image, pri, xm, ym, type, red, green, blue, alpha){
	if(red > 1){red = red/255;}
	if(green > 1){green = green/255;}
	if(blue > 1){blue = blue/255;}
	if(alpha > 1){alpha = alpha/255;}
	//will display <image>, using the objects in <pri> as the alpha mask (but uses color as the alpha)
	//persists until <obj> is deleted
	//image will horizontally move <xm> pixels per frame
	//image will vertically move <ym> pixels per frame
	IsShaderActive++;
	let pathShader = libSrc~"maskMono.hlsl";
	
	if(type == 1){pathShader = libSrc~"mask.hlsl";}
	
	
	let objShader = ObjPrim_Create(OBJ_SPRITE_2D);
	ObjShader_SetShaderF(objShader, pathShader);
	ObjShader_SetTechnique(objShader, "TecMask");

	ObjShader_SetTexture(objShader, "textureMask_", image);
	SetShaderI(objShader, pri, pri);
	ObjShader_SetFloat(objShader, "red", red);
	ObjShader_SetFloat(objShader, "green", green);
	ObjShader_SetFloat(objShader, "blue", blue);
	ObjShader_SetFloat(objShader, "alpha", alpha);
	
	let xoff = 0;
	let yoff = 0;
	
	while(!Obj_IsDeleted(obj)){
		xoff+=xm;
		yoff+=ym;
		ObjShader_SetFloat(objShader, "xoff", xoff);
		ObjShader_SetFloat(objShader, "yoff", yoff);
		yield;
	}
	IsShaderActive--;
	ResetShaderI(pri, pri);
	Obj_Delete(objShader);
}

task BackgroundBlastInA1(pri, minpri, maxpri){
	IsShaderActive++;
	IsBackgroundBlastActive = true;
	let renderTexture = "ShaderTransition";
	if(!CreateRenderTarget(renderTexture)){
	RaiseError("Not enough VRAM to proceed.\nTry restarting the game and lowering the graphics quality.");}
		
	SetInvalidRenderPriorityA1(minpri, maxpri);
	RenderToTextureA1(renderTexture, minpri, maxpri, true);
	// ClearInvalidRenderPriority;
	
	let obj = ObjPrim_Create(OBJ_SPRITE_LIST_2D);
	Obj_SetRenderPriorityI(obj, pri);
	ObjPrim_SetTexture(obj, maskSrc~"circlef.png");
	ObjSpriteList2D_SetSourceRect(obj, 0, 0, 256, 256);
	ObjSpriteList2D_SetDestRect(obj, -128, -128, 128, 128);
	
	let pulse = ObjPrim_Create(OBJ_SPRITE_LIST_2D);
	Obj_SetRenderPriorityI(pulse, pri);
	ObjPrim_SetTexture(pulse, maskSrc~"circlefdais.png");
	ObjSpriteList2D_SetSourceRect(pulse, 0, 0, 256, 256);
	ObjSpriteList2D_SetDestRect(pulse, -128, -128, 128, 128);
	DoStuff;	
	
	MaskedShaderA1(obj, renderTexture, pri, 0, 0);
	
	
	ascent(r in 0..1){
		ascent(i in 0..6){
			CreateSecondaryBlast(GetStgFrameWidth/2+rand(-128, 128), GetStgFrameHeight/2+rand(-128, 128), 70, rand(0, 360), rand(-2, 2), 1);
			// CreateIncomingBlast(GetStgFrameWidth/2, GetStgFrameHeight/2, 30, rand(0, 360), rand(-2, 2), 0.3+r/2);
			// CreatePulseR(GetStgFrameWidth/2, GetStgFrameHeight/2);
			if(!PHold(3)){break;}
		}
		if(!PHold(20)){break;}
		CreateSecondaryBlast(GetStgFrameWidth/2, GetStgFrameHeight/2, 40, 90, 0, 1);
	}
	
	PHold(30);
	// StartSlow(TARGET_ALL, 5);
	PHold(5);
	
	IsShaderActive--;
	IsBackgroundBlastActive = false;
	ClearInvalidRenderPriority;
	Obj_Delete(obj);
	RemoveTexture(renderTexture);
	
	
	task CreateSecondaryBlast(x, y, dur, ang, ainc, mscl){
		let xm = 1-2*round(rand(0, 1));
		let dist = GetStgFrameHeight*1.25;
		let mx = cos(ang);
		let my = sin(ang);
		let lx = x;
		let ly = y;
		let rscl = rand(8, 12)*mscl;
		let alpha = 255;
		
		ascent(i in 0..dur){
			ang+=ainc;
			mx = cos(ang);
			my = sin(ang);
			let mod = i/dur;
			let rmod = mod;
			let nscl = rscl*mod;
			ObjRender_SetPosition(obj, lx+mx*dist*rmod, ly+my*dist*rmod, 0);
			ObjRender_SetScaleXYZ(obj, nscl, nscl, 0);
			ObjSpriteList2D_AddVertex(obj);
			yield;
		}
	}
	task CreateIncomingBlast(x, y, dur, ang, ainc, mscl){
		let xm = 1-2*round(rand(0, 1));
		let dist = GetStgFrameHeight*1.25;
		let mx = cos(ang);
		let my = sin(ang);
		let lx = x;
		let ly = y;
		let rscl = rand(8, 12)*mscl;
		let alpha = 255;
		
		ascent(i in 0..dur){
			let mod = i/dur;
			ang+=ainc;
			let nscl = rscl*mod;
			ObjRender_SetPosition(obj, x, y, 0);
			ObjRender_SetScaleXYZ(obj, nscl*0.1, nscl, 0);
			ObjRender_SetAngleZ(obj, ang);
			ObjSpriteList2D_AddVertex(obj);
			yield;
		}
	}
	task CreatePulseR(x, y){
		descent(i in 0..25){
			let mod = i/24;
			let smod = sin(90*(1-mod));
			let scl = 3.15*smod;
			scl = scl * 7;
			ObjRender_SetPosition(obj, x, y, 0);
			ObjRender_SetAlpha(obj, 80+64*sin(-90+270*mod));
			ObjRender_SetScaleXYZ(obj, scl, scl, 1);
			ObjSpriteList2D_AddVertex(obj);
			yield;
		}
	}
	
	task DoStuff{
		while(!Obj_IsDeleted(obj)){
			ObjSpriteList2D_ClearVertexCount(obj);
			RenderToTextureA1(renderTexture, minpri, maxpri, true);
			yield;
		}
	}
}



task LayerWarpA1(minPri, maxPri, sint, aint, mint, dint, speed, time){
	if(quality < 1){return;}
	/*
	ScreenWarpA1(20, 30, 0, 0.0005, 0.01, 0.001, 1, 999999);
		minPri - Minimum priority to affect
		maxPri - Maximum priority to affect
		sint - Starting Intensity (Good value is 0)
		aint - Acceleration-of-intensity speed (Good value is 0.0005)
		mint - Maximum Intensity (will stay at this intensity until time runs out) (Good value is 0.05)
		dint - Deceleration-of-intensity speed (Good value is 0.001)
		speed - speed at which the wave occurs (good value is 4)
		time - how long the effect will last; includes starting accel; does not include ending decel
	*/
	
	IsShaderActive++;
	if(dint > 0){dint = -dint;}

	let frame = 0;

	let objWave = ObjPrim_Create(OBJ_SPRITE_2D); 
	let pathShader = libSrc~"warp.hlsl";
	ObjShader_SetShaderF(objWave, pathShader);
	ObjShader_SetTechnique(objWave, "TecMain");
	
	SetShaderI(objWave, minPri, maxPri);

	ascent(i in 0..time){
		sint = min(sint+aint, mint);
		ObjShader_SetFloat(objWave, "p_frame", frame);
		ObjShader_SetFloat(objWave, "p_int", sint);
		frame+=speed;
		yield;
	}
	
	while(sint>0){
		sint = max(sint+dint, 0);
		ObjShader_SetFloat(objWave, "p_frame", frame);
		ObjShader_SetFloat(objWave, "p_int", sint);
		frame+=speed;
		yield;
	}

	ResetShaderI(minPri, maxPri);
	IsShaderActive--;
	Obj_Delete(objWave);
}


task ScreenWarpA1(minPri, maxPri, sint, aint, mint, dint, speed, time){
	/*
	ScreenWarpA1(20, 30, 0, 0.0005, 0.01, 0.001, 1, 999999);
		minPri - Minimum priority to affect
		maxPri - Maximum priority to affect
		sint - Starting Intensity (Good value is 0)
		aint - Acceleration-of-intensity speed (Good value is 0.0005)
		mint - Maximum Intensity (will stay at this intensity until time runs out) (Good value is 0.05)
		dint - Deceleration-of-intensity speed (Good value is 0.001)
		speed - speed at which the wave occurs (good value is 4)
		time - how long the effect will last; includes starting accel; does not include ending decel
	*/
	
	IsShaderActive++;
	if(dint > 0){dint = -dint;}
	
	let renderTexture = GetReservedRenderTargetName(0);
	SetInvalidRenderPriorityA1(minPri, maxPri);

	let frame = 0;

	let frameWidth = GetStgFrameWidth;
	let frameHeight = GetStgFrameHeight;
	let frameLeft = GetStgFrameLeft;
	let frameRight = frameLeft + frameWidth;
	let frameTop = GetStgFrameTop;
	let frameBottom = frameTop + frameHeight;

	let objWave = ObjPrim_Create(OBJ_SPRITE_2D); 
	Obj_SetRenderPriorityI(objWave, maxPri + 1);
	ObjPrim_SetTexture(objWave, renderTexture);
	ObjSprite2D_SetSourceRect(objWave, frameLeft, frameTop, frameRight, frameBottom);
	ObjSprite2D_SetDestRect(objWave, GetStgFrameWidth/2-frameWidth/2, GetStgFrameHeight/2-frameHeight/2, 
		GetStgFrameWidth/2+frameWidth/2, GetStgFrameHeight/2+frameHeight/2);
		
	

	let pathShader = libSrc~"warp.hlsl";
	ObjShader_SetShaderF(objWave, pathShader);
	ObjShader_SetTechnique(objWave, "TecMain");

	ascent(i in 0..time){
		RenderToTextureA1(renderTexture, minPri, maxPri, true);
		sint = min(sint+aint, mint);
		ObjRender_SetX(objWave, -GetStgFrameWidth*sint*2.5);
		ObjRender_SetScaleX(objWave, 1+sint*4);
		ObjShader_SetFloat(objWave, "p_frame", frame);
		ObjShader_SetFloat(objWave, "p_int", sint);
		frame+=speed;
		yield;
	}
	
	while(sint>0){
		RenderToTextureA1(renderTexture, minPri, maxPri, true);
		sint = max(sint+dint, 0);
		ObjShader_SetFloat(objWave, "p_frame", frame);
		ObjShader_SetFloat(objWave, "p_int", sint);
		frame+=speed;
		yield;
	}

	IsShaderActive--;
	Obj_Delete(objWave);
	ClearInvalidRenderPriority;
}

task ScreenShatterA1(minpri, maxpri){
	IsShaderActive++;
	let renderTexture = "PixelShaderFuncShatter";
	let count = 0;
	let pathShader = libSrc~"maskMono.hlsl";
	let pathMask = pixelSrc~"img/Masks/glass.png";
	if(!CreateRenderTarget(renderTexture)){
	RaiseError("Not enough VRAM to proceed.\nTry restarting the game and lowering the graphics quality.");}
		
	SetInvalidRenderPriorityA1(minpri, maxpri);
	Reset2DCamera;
	RenderToTextureA1(renderTexture, minpri, maxpri, true);
	ClearInvalidRenderPriority;
	
	let objShader = ObjPrim_Create(OBJ_SPRITE_2D);
	ObjShader_SetShaderF(objShader, pathShader);
	ObjShader_SetTechnique(objShader, "TecMask");

	ObjShader_SetTexture(objShader, "textureMask_", renderTexture);
	SetShaderI(objShader, maxpri, maxpri);
	
	let countx = 30;
	let county = 10;
	
	
	let obj = ObjPrim_Create(OBJ_SPRITE_LIST_2D);
	Obj_SetRenderPriority(obj, maxpri/100);
	ObjPrim_SetTexture(obj, pathMask);
	
	ascent(x in 0..countx){
		ascent(y in 0..county){
			CreateFragmentA1(GetStgFrameWidth/countx*x+rand(-16, 16), GetStgFrameHeight/county*y+rand(-16, 16));
		}
	}
	yield;
	while(count > 0){yield;}
	IsShaderActive--;
	ObjShader_ResetShader(objShader);
	ResetShaderI(maxpri, maxpri);
	RemoveTexture(renderTexture);
	Obj_Delete(objShader);

	yield;
	
	
	task CreateFragmentA1(x, y){
		count++;
		let obj = ObjPrim_Create(OBJ_SPRITE_2D);
		ObjRender_SetBlendType(obj, BLEND_ALPHA);
		ObjRender_SetAlpha(obj, 255);
		Obj_SetRenderPriority(obj, maxpri/100);
		ObjPrim_SetTexture(obj, pathMask);
		
		let xoff = round(rand(0,7));
		let yoff = round(rand(0,7));
		
		ObjRender_SetScaleXYZ(obj, 1.5, 1.5, 1.5);
		ObjSprite2D_SetSourceRect(obj, xoff*48, yoff*48, (xoff+1)*48, (yoff+1)*48);
		ObjSprite2D_SetDestCenter(obj);
		
		let mid = GetStgFrameWidth/2;
		let data = [0, 0, 0, 
		(((x-mid)/mid)*rand(0, 5) + rand(-1,1))*2, 
		(2-absolute((x-mid)/mid)*3+rand(-1, 2))*0.70];
		
		let datamov = [rand(-8, 8), rand(-8, 8), rand(-8, 8), 0, 0.022];
		ObjRender_SetPosition(obj, x, y, 0);
		ObjRender_SetAngleXYZ(obj, data[0], data[1], data[2]);
		while(y<GetStgFrameHeight+64&&x<GetStgFrameWidth+64&&x>-64){
			ObjRender_SetPosition(obj, x, y, 0);
			ObjRender_SetAngleXYZ(obj, data[0], data[1], data[2]);
			
			
			data += datamov;
			datamov[4] = datamov[4]*1.06;
			x += data[3];
			y += data[4];
			
			yield;
		}
		Obj_Delete(obj);
		count--;
	}
}

task ScreenShatterB1(image, minpri, maxpri){
	IsShaderActive++;
	let renderTexture = "PixelShaderFuncShatter";
	let count = 0;
	let pathShader = libSrc~"mask.hlsl";
	let pathMask = pixelSrc~"img/Masks/glass.png";
	if(!CreateRenderTarget(renderTexture)){
	RaiseError("Not enough VRAM to proceed.\nTry restarting the game and lowering the graphics quality.");}
		
	SetInvalidRenderPriorityA1(minpri, maxpri);
	Reset2DCamera;
	RenderToTextureA1(renderTexture, minpri, maxpri, true);
	ClearInvalidRenderPriority;
	
	let objShader = ObjPrim_Create(OBJ_SPRITE_2D);
	ObjShader_SetShaderF(objShader, pathShader);
	ObjShader_SetTechnique(objShader, "TecMask");

	ObjShader_SetTexture(objShader, "textureMask_", renderTexture);
	SetShaderI(objShader, maxpri, maxpri);
	
	let countx = 30;
	let county = 10;
	ascent(x in 0..countx){
		ascent(y in 0..county){
			CreateFragmentA1(GetStgFrameWidth/countx*x+rand(-16, 16), GetStgFrameHeight/county*y+rand(-16, 16));
		}
	}
	yield;
	while(count > 0){yield;}
	IsShaderActive--;
	ObjShader_ResetShader(objShader);
	ResetShaderI(maxpri, maxpri);
	RemoveTexture(renderTexture);
	Obj_Delete(objShader);

	yield;
	
	
	task CreateFragmentA1(x, y){
		count++;
		let obj = ObjPrim_Create(OBJ_SPRITE_2D);
		ObjRender_SetBlendType(obj, BLEND_ALPHA);
		ObjRender_SetAlpha(obj, 255);
		Obj_SetRenderPriority(obj, maxpri/100);
		ObjPrim_SetTexture(obj, pathMask);
		let ranxy = [round(rand(0,7)), round(rand(0,7))];
		ObjRender_SetScaleXYZ(obj, 1.5, 1.5, 1.5);
		ObjSprite2D_SetSourceRect(obj, ranxy[0]*48, ranxy[1]*48, (ranxy[0]+1)*48, (ranxy[1]+1)*48);
		ObjSprite2D_SetDestCenter(obj);
		
		let mid = GetStgFrameWidth/2;
		let data = [0, 0, 0, 
		(((x-mid)/mid)*rand(0, 5) + rand(-1,1))*2, 
		(2-absolute((x-mid)/mid)*3+rand(-1, 2))*0.70];
		
		let datamov = [rand(-8, 8), rand(-8, 8), rand(-8, 8), 0, 0.022];
		ObjRender_SetPosition(obj, x, y, 0);
		ObjRender_SetAngleXYZ(obj, data[0], data[1], data[2]);
		while(y<GetStgFrameHeight+64&&x<GetStgFrameWidth+64&&x>-64){
			ObjRender_SetPosition(obj, x, y, 0);
			ObjRender_SetAngleXYZ(obj, data[0], data[1], data[2]);
			
			
			data += datamov;
			datamov[4] = datamov[4]*1.06;
			x += data[3];
			y += data[4];
			
			yield;
		}
		Obj_Delete(obj);
		count--;
	}
}


//pixel shader variant
function PHold(yielder){
	loop(yielder){
		// if(EnemyDead){return false;}
		yield;
	}
	return true;
}

/*
task TimeStopL2(duration){
	// Background is render targetted; mask will "remove" the timestop
	// No quality setting consideration, slightly outdated code, needs improvements
	let bspeed = GetCommonData("stgspeed", 3);
	
	let RecoveryTime = 12;
	let minpri = 20;
	let maxpri = 29;
	
	let renderTexture = "SpellTimeStop";
	let pathShader = libSrc~"monochrome.hlsl";
	let pathMask = pixelSrc~"img/Masks/circlefdr.png";
	let pathMaskBG = pixelSrc~"img/Masks/blank.png";
	if(!CreateRenderTarget(renderTexture)){
	RaiseError("Not enough VRAM to proceed.\nTry restarting the game and lowering the graphics quality.");}
		
	SetInvalidRenderPriorityA1(minpri, maxpri);
	Reset2DCamera;
	RenderToTextureA1(renderTexture, minpri, maxpri, true);
	ClearInvalidRenderPriority;
	
	let objShader = ObjPrim_Create(OBJ_SPRITE_2D);
	ObjShader_SetShaderF(objShader, pathShader);
	ObjShader_SetTechnique(objShader, "TecMask");

	ObjShader_SetTexture(objShader, "textureMask_", renderTexture);
	SetShaderI(objShader, maxpri, maxpri);
	
	IsTimeStoppedPseudo = true;
	
	CreateTimeField(GetPlayerObjectID, timezonescale);
	
	let frame = 0;
	let sint = 0.003;
	SetCommonData("stgspeed", 0);
	ascent(i in 0..duration-RecoveryTime){
		if(EnemyDead){break;}
		PerformProperties;
		yield;
	}
	
	IsTimeStoppedPseudo = false;
	
	ascent(i in 0..RecoveryTime){
		SetCommonData("stgspeed", bspeed/RecoveryTime*i);
		PerformProperties;
		yield;
	}
	SetCommonData("stgspeed", bspeed);
	
	ObjShader_ResetShader(objShader);
	ResetShaderI(maxpri, maxpri);
	RemoveTexture(renderTexture);
	Obj_Delete(objShader);
	
	
	sub PerformProperties{
		frame++;
		ObjShader_SetFloat(objShader, "p_frame", frame);
		ObjShader_SetFloat(objShader, "p_int", sint);
	}
	
	task CreateTimeField(dobj, scl){
		yield;
		let obj = ObjPrim_Create(OBJ_SPRITE_2D);
		ObjRender_SetBlendType(obj, BLEND_ALPHA);
		Obj_SetRenderPriority(obj, maxpri/100);
		ObjPrim_SetTexture(obj, pathMask);
		ObjSprite2D_SetSourceRect(obj, 0, 0, 1024, 1024);
		ObjSprite2D_SetDestCenter(obj);
		ObjRender_SetScaleXYZ(obj, scl, scl, scl);
		
		while(IsTimeStoppedPseudo){
			ObjRender_SetPosition(obj, ObjMove_GetX(dobj), ObjMove_GetY(dobj), 0);
			yield;
		}
		descent(i in 0..RecoveryTime){
			ObjRender_SetAlpha(obj, 255/RecoveryTime*i);
			ObjRender_SetPosition(obj, ObjMove_GetX(dobj), ObjMove_GetY(dobj), 0);
			yield;
		}
		
		Obj_Delete(obj);
	}	
}

*/

task ColorWarpA1(minpri, maxpri, period, horiz, verti){
	if(quality < 2){return;}
	IsShaderActive++;
	
	//try, 20, 30, 0.1, 30, 30
	
	let pathShader = libSrc~"colorRainbow.hlsl";
	
	let objShader = ObjPrim_Create(OBJ_SPRITE_2D);
	ObjShader_SetShaderF(objShader, pathShader);
	ObjShader_SetTechnique(objShader, "TecRainbow");
	ObjShader_SetFloat(objShader, "s_period", period);
	ObjShader_SetFloat(objShader, "s_horiz", horiz);
	ObjShader_SetFloat(objShader, "s_verti", verti);
	ObjShader_SetFloat(objShader, "s_angle", 0);
	

	SetShaderI(objShader, minpri, maxpri);
	
	let frame = 0;
	
	loop{
		ObjShader_SetFloat(objShader, "s_angle", frame);
		frame+=5;
		yield;
	}
	
	IsShaderActive--;
	ObjShader_ResetShader(objShader);
	ResetShaderI(minpri, maxpri);
	Obj_Delete(objShader);
}	


task BasicBlurA1(minpri, maxpri, idur, duration, edur){
	if(quality < 1){return;}
	IsShaderActive++;
	
	//try, 20, 30, 0.1, 30, 30
	
	// let pathShader = libSrc~"Blur.dnhfx";
	let pathShader = libSrc~"blur8waysquare_HLSL.dnh";
	
	let objShader = ObjPrim_Create(OBJ_SPRITE_2D);
	ObjShader_SetShaderF(objShader, pathShader);
	ObjShader_SetTechnique(objShader, "TecBlurSquare");
		ObjShader_SetFloat(objShader, "transit", 0);
	
	// let renderTexture = "PixelShaderFuncShatter";
	// if(!CreateRenderTarget(renderTexture)){
	// RaiseError("Not enough VRAM to proceed.\nTry restarting the game and lowering the graphics quality.");}
		
	// SetInvalidRenderPriorityA1(minpri, maxpri);
	
	
	// ObjShader_SetTexture(objShader, "textureMask_", renderTexture);

	SetShaderI(objShader, minpri, maxpri);
	
	// let obj = ObjPrim_Create(OBJ_SPRITE_2D);
	// Obj_SetRenderPriority(obj, maxpri/100);
	// ObjPrim_SetTexture(obj, renderTexture);
	// ObjSprite2D_SetSourceRect(obj, 0, 0, GetStgFrameWidth, GetStgFrameHeight);
	// ObjSprite2D_SetDestRect(obj, 0, 0, GetStgFrameWidth, GetStgFrameHeight);
	
	
// float alpha_pix = 1;
// float bcount = 3;
// float transit = 0;

	ascent(i in 0..idur){
		let mod = i/(idur-1);
		ObjShader_SetFloat(objShader, "transit", mod);
		yield;
	}
	
	ascent(i in 0..duration){
		yield;
	}
	
	descent(i in 0..edur){
		let mod = i/(edur-1);
		ObjShader_SetFloat(objShader, "transit", mod);
		yield;
	}
	
	IsShaderActive--;
	ObjShader_ResetShader(objShader);
	// ClearInvalidRenderPriority;
	ResetShaderI(minpri, maxpri);
	Obj_Delete(objShader);
}	


